unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmMain = class(TForm)
    txtMensaje: TEdit;
    Label1: TLabel;
    btnCifrar: TButton;
    txtClave: TEdit;
    Label2: TLabel;
    procedure btnCifrarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses SHA256, AES;

procedure TfrmMain.btnCifrarClick(Sender: TObject);
var
  Texto, Clave: AnsiString;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
  State, IV: TAESState;
  T: AnsiString;
  i,j,k: Integer;
begin
  Texto:= Trim(txtMensaje.Text);
  if Texto = EmptyStr then
    Exit;
  Clave:= Trim(txtClave.Text);
  if Clave = EmptyStr then
    Exit;
  // Calculamos el hash de la clave y lo usamos como clave de cifrado
  TSHA256HASH(Key):= CalcSHA256(Clave);
  AEsExpandKey(ExpandedKey,Key);
  FillChar(IV,Sizeof(IV),#0);
  k:= 0;
  T:= '(' + #13;
  // Ciframos trozo a trozo usando el metodo CBC
  while Length(Texto) > 0 do
  begin
    inc(k);
    FillChar(State,Sizeof(State),#0);
    // Leemos un trozo
    if Length(Texto) >= Sizeof(State) then
      move(PAnsiChar(Texto)^,State,Sizeof(State))
    else
      move(PAnsiChar(Texto)^,State,Length(Texto));
    System.Delete(Texto,1,Sizeof(State));
    XORState(State,IV);
    // Lo ciframos
    AESEncrypt(State,ExpandedKey);
    IV:= State;
    T:= T + '(';
    // Lo convertimos en una constante que el compilador de Pascal
    // puede entender
    for i:= 0 to 3 do
    begin
      T:= T + '(';
      for j:= 0 to 3 do
      begin
        T:= T + IntToStr(State[i,j]);
        if j<3 then T:= T + ',';
      end;
      if i<3 then T:= T + '),';
    end;
    T:= T + ')),' + #13;;
  end;
  System.Delete(T,Length(T)-1,2);
  T:= Format('T: array[0..%d] of TAESState = %s);',[k-1,T]);
  // Abrimos el codigo e introducimos la nueva constante
  with TStringList.Create do
  try
    LoadFromFile(ChangeFileExt(ParamStr(0),'.dat'));
    Text:= StringReplace(Text,'$MENSAJECIFRADO$',T,[rfReplaceAll,rfIgnoreCase]);
    with TSaveDialog.Create(nil) do
    try
      if Execute then
      begin
        Text:= StringReplace(Text,'$NOMBREPROGRAMA$',
          ChangeFileExt(ExtractFileName(Filename),EmptyStr),
          [rfReplaceAll,rfIgnoreCase]);
        SaveToFile(ChangeFileExt(Filename,'.pas'));
      end;
    finally
      Free;
    end;
  finally
    Free;
  end;
end;

end.
